#
#   Python GUI - Containers - PyObjC version
#

from AppKit import NSView
from GContainers import Container as GContainer

class Container(GContainer):
    #  _ns_inner_view   NSView   Containing NSView for subcomponents
    
    def __init__(self, _ns_view, _ns_inner_view = None, **kwds):
        if not _ns_inner_view:
            _ns_inner_view = _ns_view
        self._ns_inner_view = _ns_inner_view
        GContainer.__init__(self, _ns_view = _ns_view, **kwds)
    
    def destroy(self):
        #print "Container.destroy:", self ###
        GContainer.destroy(self)
        #print "Container.destroy: breaking inner link to", self._ns_inner_view ###
        self._ns_inner_view = None

    def _add(self, comp):
        GContainer._add(self, comp)
        self._ns_inner_view.addSubview_(comp._ns_view)

    def _remove(self, comp):
        GContainer._remove(self, comp)
        comp._ns_view.removeFromSuperview()

#------------------------------------------------------------------------------

class PyGUI_Flipped_NSView(NSView):
    #  An NSView with a flipped coordinate system.
    
    def isFlipped(self):
        return True
