#
#   Standard cursors test
#

from GUI import Window, View, StdCursors, \
    RadioGroup, RadioButton, application
from GUI.StdColors import black, white

cursor_names = []
for name in dir(StdCursors):
    if not name.startswith("__"):
        cursor_names.append(name)

class TestArea(View):

    def draw(self, c, r):
        c.forecolor = white
        c.fill_rect(r)
        c.forecolor = black
        w, h = self.size
        c.frame_rect((0, 0, w, h))

def test():
    def select():
        i = group.value
        print "Selecting cursor", i
        view.cursor = getattr(StdCursors, cursor_names[i])
    win = Window(title = "Std Cursors")
    view = TestArea(size = (100, 100))
    win.place(view, left = 20, top = 20)
    group = RadioGroup(action = select)
    for i, name in enumerate(cursor_names):
        group.add(RadioButton(title = name, value = i))
    win.place_column(group, left = view + 20, top = 20, spacing = 0)
    win.shrink_wrap((20, 20))
    win.show()
    application().run()

test()
